]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blame - make.sh
red + pppsetup.cgi von Arne.
[people/pmueller/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06209efc 20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
06209efc
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
0b2ebeac 27VERSION="2.0rc1t" # Version number
06209efc
MT
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
8f7b33ea 36IPFVER="full" # Which versions should be compiled? (full|devel)
03ad5f93
MT
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
1b273e8f 85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
df5e82b3
MT
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
1b273e8f 89 exiterror "Not running BASH shell."
df5e82b3
MT
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
1b273e8f
MT
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
15679d9f 111 else
1b273e8f 112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
1b273e8f
MT
123 beautify message FAIL
124 exiterror "Not building as root"
15679d9f 125 else
1b273e8f 126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
1b273e8f
MT
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
15679d9f 144 else
1b273e8f 145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
1b273e8f 164 ln -s $BASEDIR/build/tools /
df5e82b3
MT
165 fi
166 if [ ! -h /tools ]; then
1b273e8f 167 exiterror "Could not create /tools symbolic link."
df5e82b3
MT
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
1179dc27 173 MAKETUNING="-j6"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
9b0ff0a0
MT
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
df5e82b3 291 lfsmake2 gzip
9b0ff0a0
MT
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
44254afd 296 lfsmake2 libaal
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65f8f30f 301 lfsmake2 mtd
65998e0a 302 lfsmake2 net-tools
df5e82b3 303 lfsmake2 patch
df5e82b3 304 lfsmake2 psmisc
44254afd 305 lfsmake2 reiser4progs
df5e82b3
MT
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
90d372c4
MT
310 lfsmake2 texinfo
311 lfsmake2 udev
df5e82b3 312 lfsmake2 util-linux
90d372c4 313 lfsmake2 vim
44254afd 314 lfsmake2 grub
df5e82b3
MT
315}
316
15679d9f 317buildipfire() {
907cd036 318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 319 export LOGFILE
15679d9f
MT
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
15679d9f
MT
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
3a1019f6 328 ipfiremake linux SMP=1
552b817b 329 ipfiremake ipp2p SMP=1
bb5774c8 330 ipfiremake r8169 SMP=1
dd001658 331 ipfiremake zaptel SMP=1
c3e36980 332 ipfiremake linux
552b817b 333 ipfiremake ipp2p
bb5774c8 334 ipfiremake r8169
119f6ad3 335 ipfiremake zaptel
c545beb1 336 ipfiremake pkg-config
a89770fa 337 ipfiremake linux-atm
ad9d4caf 338 ipfiremake cpio
ee78a5ef
MT
339 ipfiremake klibc
340 ipfiremake mkinitcpio
341 ipfiremake udev KLIBC=1
15679d9f
MT
342 ipfiremake expat
343 ipfiremake gdbm
344 ipfiremake gmp
c8ead4a5 345 ipfiremake pam
15679d9f 346 ipfiremake openssl
eac942d9 347 ipfiremake curl
15679d9f
MT
348 ipfiremake python
349 ipfiremake libnet
27b8cc24 350 ipfiremake libidn
ddac6087 351 ipfiremake libjpeg
15679d9f
MT
352 ipfiremake libpng
353 ipfiremake libtiff
fd3e7da0 354 ipfiremake libart
9594506f 355 ipfiremake freetype
15679d9f
MT
356 ipfiremake gd
357 ipfiremake popt
411afd1f 358 ipfiremake pcre
15679d9f
MT
359 ipfiremake slang
360 ipfiremake newt
fd3e7da0 361 ipfiremake libcap
15679d9f 362 ipfiremake pciutils
51f3b7f5 363 ipfiremake usbutils
15679d9f 364 ipfiremake libxml2
c6c9630e 365 ipfiremake libxslt
6b8cff41 366 ipfiremake BerkeleyDB
15679d9f 367 ipfiremake mysql
411afd1f 368 ipfiremake cyrus-sasl
15679d9f
MT
369 ipfiremake openldap
370 ipfiremake apache2
371 ipfiremake php
a10ae6cc 372 ipfiremake apache2 PASS=C
15679d9f
MT
373 ipfiremake arping
374 ipfiremake beep
375 ipfiremake bind
15679d9f
MT
376 ipfiremake cdrtools
377 ipfiremake dnsmasq
378 ipfiremake dosfstools
444973a4 379 ipfiremake squashfstools
72d80898 380 ipfiremake reiserfsprogs
93afd047 381 ipfiremake sysfsutils
8e055e65 382 ipfiremake fuse
d02350a2 383 ipfiremake ntfs-3g
15679d9f
MT
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
e3670217 387 ipfiremake perl-GD
330345c2 388 ipfiremake GD-Graph
786f2c8a 389 ipfiremake GD-TextUtil
15679d9f
MT
390 ipfiremake gnupg
391 ipfiremake hdparm
f9956330 392 ipfiremake sdparm
7861f575 393 ipfiremake mtools
15679d9f 394 ipfiremake initscripts
406f019f 395 ipfiremake whatmask
15679d9f 396 ipfiremake iptables
490256d5 397 ipfiremake libupnp
552b817b 398 ipfiremake ipp2p IPT=1
81a7e7c8 399 ipfiremake moblock
490256d5 400 ipfiremake linux-igd
15679d9f
MT
401 ipfiremake ipac-ng
402 ipfiremake ipaddr
15679d9f 403 ipfiremake iptstate
fd3e7da0 404 ipfiremake iputils
15679d9f 405 ipfiremake l7-protocols
8bba2965 406 ipfiremake mISDN
93afd047 407 ipfiremake hwdata
72d80898 408 ipfiremake kudzu
15679d9f
MT
409 ipfiremake logrotate
410 ipfiremake logwatch
15679d9f 411 ipfiremake misc-progs
15679d9f 412 ipfiremake nano
15679d9f
MT
413 ipfiremake nasm
414 ipfiremake URI
415 ipfiremake HTML-Tagset
416 ipfiremake HTML-Parser
417 ipfiremake Compress-Zlib
418 ipfiremake Digest
419 ipfiremake Digest-SHA1
420 ipfiremake Digest-HMAC
421 ipfiremake libwww-perl
422 ipfiremake Net-DNS
423 ipfiremake Net-IPv4Addr
424 ipfiremake Net_SSLeay
425 ipfiremake IO-Stringy
426 ipfiremake Unix-Syslog
427 ipfiremake Mail-Tools
428 ipfiremake MIME-Tools
429 ipfiremake Net-Server
430 ipfiremake Convert-TNEF
431 ipfiremake Convert-UUlib
432 ipfiremake Archive-Tar
433 ipfiremake Archive-Zip
434 ipfiremake Text-Tabs+Wrap
435 ipfiremake Locale-Country
93afd047 436 ipfiremake XML-Parser
c5568d64 437 ipfiremake glib
15679d9f
MT
438 ipfiremake GeoIP
439 ipfiremake fwhits
440 ipfiremake noip_updater
441 ipfiremake ntp
15679d9f
MT
442 ipfiremake openssh
443 ipfiremake openswan
15679d9f
MT
444 ipfiremake rrdtool
445 ipfiremake setserial
446 ipfiremake setup
447 ipfiremake snort
8a5604bf 448 ipfiremake oinkmaster
15679d9f
MT
449 ipfiremake squid
450 ipfiremake squid-graph
451 ipfiremake squidguard
069ae085 452 ipfiremake calamaris
6f00de0d 453 ipfiremake tcpdump
15679d9f
MT
454 ipfiremake traceroute
455 ipfiremake vlan
456 ipfiremake wireless
457 ipfiremake libsafe
15679d9f 458 ipfiremake pakfire
15679d9f 459 ipfiremake java
15679d9f
MT
460 ipfiremake spandsp
461 ipfiremake lzo
462 ipfiremake openvpn
15679d9f 463 ipfiremake pammysql
15679d9f 464 ipfiremake cups
fccb3371
MT
465 ipfiremake ghostscript
466 ipfiremake foomatic
15679d9f
MT
467 ipfiremake samba
468 ipfiremake sudo
469 ipfiremake mc
470 ipfiremake wget
15679d9f
MT
471 ipfiremake bridge-utils
472 ipfiremake screen
473 ipfiremake hddtemp
474 ipfiremake smartmontools
475 ipfiremake htop
15679d9f 476 ipfiremake postfix
15679d9f
MT
477 ipfiremake fetchmail
478 ipfiremake cyrusimap
58493e1e 479 ipfiremake openmailadmin
15679d9f
MT
480 ipfiremake mailx
481 ipfiremake clamav
15679d9f 482 ipfiremake spamassassin
fd3e7da0 483 ipfiremake amavisd
0708852c 484 ipfiremake alsa
15679d9f 485 ipfiremake mpg123
a28fdc01 486 ipfiremake mpfire
6c98857b 487 ipfiremake guardian
67081922 488 ipfiremake libid3tag
15679d9f
MT
489 ipfiremake libmad
490 ipfiremake libogg
491 ipfiremake libvorbis
492 ipfiremake lame
15679d9f 493 ipfiremake sox
a6931e7e
MT
494 ipfiremake libshout
495 ipfiremake icecast
909d16ee 496 ipfiremake icegenerator
71043200 497 ipfiremake mpd
f86b0cc3 498 ipfiremake mpc
24fd09e4
MT
499 ipfiremake xvid
500 ipfiremake libmpeg2
501 #ipfiremake ffmpeg
502 ipfiremake videolan
0708852c
MT
503 ipfiremake libpri
504 ipfiremake stund
0708852c
MT
505 ipfiremake asterisk
506 ipfiremake backup
15679d9f 507 ipfiremake gnump3d
eac942d9 508 ipfiremake libsigc++
15679d9f
MT
509 ipfiremake applejuice
510 ipfiremake ocaml
511 ipfiremake mldonkey
eac942d9
MT
512 ipfiremake libtorrent
513 ipfiremake rtorrent
06209efc 514 ipfiremake ipfireseeder
15679d9f
MT
515 ipfiremake rsync
516 ipfiremake tcpwrapper
517 ipfiremake portmap
518 ipfiremake nfs
519 ipfiremake nmap
520 ipfiremake mbmon
521 ipfiremake iftop
522 ipfiremake ncftp
523 ipfiremake cftp
524 ipfiremake etherwake
525 ipfiremake ethereal
526 ipfiremake tftp-hpa
06da1292 527 ipfiremake bwm-ng
1a8688ba
MT
528 ipfiremake tripwire
529 ipfiremake sysstat
a08c3a2e 530 ipfiremake vsftpd
51f3b7f5 531 ipfiremake which
186e3d2c 532 ipfiremake lsof
df5e82b3
MT
533}
534
535buildinstaller() {
536 # Run installer scripts one by one
537 LOGFILE="$BASEDIR/log/_build.installer.log"
538 export LOGFILE
0afc6d83 539 ipfiremake syslinux
4dc82852
MT
540 ipfiremake as86
541 ipfiremake mbr
fd0763dc 542 ipfiremake memtest
bc9f0c12
MT
543 installmake linux-libc-header
544 installmake binutils
545 ipfiremake uClibc PASS=1
546 ipfiremake gcc INST=1
547 installmake uClibc PASS=2
548 installmake gcc INST=2
549 installmake uClibc PASS=3
df5e82b3 550 installmake busybox
c66941dd 551 installmake udev
33634aa8
MT
552 installmake slang
553 installmake newt
72d80898 554 installmake gettext
33634aa8
MT
555 installmake kbd
556 installmake popt
33634aa8 557 installmake sysvinit
df5e82b3 558 installmake misc-progs
44254afd
MT
559 installmake libaal
560 installmake reiser4progs
89069053 561 installmake reiserfsprogs
a6316ce4 562 installmake sysfsutils
df5e82b3 563 installmake util-linux
df5e82b3 564 installmake pciutils
c5568d64 565 installmake zlib
65f8f30f 566 installmake mtd
c78a77eb 567 installmake wget
93afd047 568 installmake hwdata
fcb5057d 569 installmake kudzu
df5e82b3 570 installmake installer
df5e82b3 571 installmake initrd
df5e82b3
MT
572}
573
574buildpackages() {
575 LOGFILE="$BASEDIR/log/_build.packages.log"
576 export LOGFILE
577 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 578
edd536b6 579 installmake strip
df5e82b3
MT
580
581 # Generating list of packages used
0fbb45e9 582 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
583 rm -f $BASEDIR/doc/packages-list
584 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
585 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 586 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
587 fi
588 done
7471f6ab 589 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 590 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
591 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
592 rm -f $BASEDIR/doc/packages-list
c9673262 593 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 594 beautify message DONE
df5e82b3 595
9607771a 596 # Create images for install
74dbbc36
MT
597 ipfiremake cdrom ED=full
598
4dc82852 599 # Check if there is a loop device for building in virtual environments
eedc26d9 600 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
4dc82852
MT
601 ipfiremake usb-stick
602 fi
4dc82852 603 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
c9673262 604
0d909a4a 605 ipfirepackages
e67a57fe
MT
606
607 # Cleanup
608 stdumount
609 rm -rf $BASEDIR/build/tmp/*
610
611 # Generating total list of files
0d909a4a 612 echo -n "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
613 rm -f $BASEDIR/log/FILES
614 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
615 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
616 echo "##" >>$BASEDIR/log/FILES
617 echo "## `basename $i`" >>$BASEDIR/log/FILES
618 echo "##" >>$BASEDIR/log/FILES
619 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
620 fi
621 done
0d909a4a 622 beautify message DONE
e67a57fe
MT
623
624 cd $PWD
e67a57fe
MT
625}
626
627ipfirepackages() {
a5997a4c 628 ipfiremake core-updates
fe7fe395 629 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
453b418b
MT
630 if [ -e $BASEDIR/lfs/$i ]; then
631 ipfiredist $i
632 else
633 echo -n $i
634 beautify message SKIP
635 fi
fe7fe395 636 done
78331e30 637 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 638 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 639 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
640}
641
642# See what we're supposed to do
643case "$1" in
644build)
9729e787 645 clear
df5e82b3 646 BUILDMACHINE=`uname -m`
712d859c 647 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 648 #only restore on a clean disk
9b0ff0a0 649 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 650 if [ ! -n "$PACKAGE" ]; then
15679d9f 651 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
652 prepareenv
653 buildtoolchain
654 else
655 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 656 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
657 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
658 tar zxf $PACKAGE
659 prepareenv
660 else
661 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
662 fi
663 fi
664 else
9729e787
MT
665 echo -n "Using installed toolchain" | tee -a $LOGFILE
666 beautify message SKIP
df5e82b3
MT
667 prepareenv
668 fi
5cfe86e6 669
7ab7a9b4 670 beautify build_start
0b59f25c 671 beautify build_stage "Building LFS"
df5e82b3 672 buildbase
15679d9f 673
0b59f25c 674 beautify build_stage "Building IPFire"
15679d9f 675 buildipfire
5cfe86e6
HS
676
677 # Setzen des IPFire Builds
8af06406 678 if [ "$FIREBUILD" ]; then
e57bc1fd 679 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 680 else
e57bc1fd 681 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
682 fi
683
0b59f25c 684 beautify build_stage "Building installer"
df5e82b3 685 buildinstaller
15679d9f 686
0b59f25c 687 beautify build_stage "Building packages"
df5e82b3 688 buildpackages
7ab7a9b4 689 beautify build_end
df5e82b3
MT
690 ;;
691shell)
692 # enter a shell inside LFS chroot
693 # may be used to changed kernel settings
694 prepareenv
695 entershell
696 ;;
697changelog)
d1dd6669 698 echo -n "Loading new Changelog from SVN: "
223ad6a4 699 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
a50d04ab 700 beautify message DONE
df5e82b3 701 ;;
df5e82b3 702clean)
a50d04ab 703 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
704 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
705 $LOSETUP -d $i 2>/dev/null
706 done
707 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
708 umount $i
709 done
710 stdumount
711 for i in `seq 0 7`; do
712 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
713 umount /dev/loop${i} 2>/dev/null;
714 losetup -d /dev/loop${i} 2>/dev/null;
715 fi;
716 done
717 rm -rf $BASEDIR/build
718 rm -rf $BASEDIR/cdrom
f9315063 719 rm -rf $BASEDIR/packages
df5e82b3 720 rm -rf $BASEDIR/log
df5e82b3
MT
721 if [ -h /tools ]; then
722 rm -f /tools
723 fi
a50d04ab 724 beautify message DONE
df5e82b3 725 ;;
c3db995c 726downloadsrc)
df5e82b3
MT
727 if [ ! -d $BASEDIR/cache ]; then
728 mkdir $BASEDIR/cache
729 fi
730 mkdir -p $BASEDIR/log
857d9bf2 731 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
732 FINISHED=0
733 cd $BASEDIR/lfs
734 for c in `seq $MAX_RETRIES`; do
735 if (( FINISHED==1 )); then
736 break
737 fi
738 FINISHED=1
739 cd $BASEDIR/lfs
740 for i in *; do
741 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 742 echo -ne "Loading $i"
df5e82b3
MT
743 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
744 if [ $? -ne 0 ]; then
e22c7973 745 beautify message FAIL
df5e82b3
MT
746 FINISHED=0
747 else
748 if [ $c -eq 1 ]; then
e22c7973 749 beautify message DONE
df5e82b3
MT
750 fi
751 fi
752 fi
753 done
754 done
e22c7973 755 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
756 ERROR=0
757 for i in *; do
758 if [ -f "$i" -a "$i" != "Config" ]; then
759 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
760 if [ $? -ne 0 ]; then
e22c7973
MT
761 echo -ne "MD5 difference in lfs/$i"
762 beautify message FAIL
df5e82b3
MT
763 ERROR=1
764 fi
765 fi
766 done
767 if [ $ERROR -eq 0 ]; then
e22c7973
MT
768 echo -ne "${BOLD}all files md5sum match${NORMAL}"
769 beautify message DONE
770 else
771 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
772 beautify message FAIL
df5e82b3 773 fi
e22c7973 774 cd - >/dev/null 2>&1
df5e82b3 775 ;;
df5e82b3 776toolchain)
9729e787 777 clear
df5e82b3 778 prepareenv
15679d9f 779 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
780 buildtoolchain
781 BUILDMACHINE=`uname -m`
782 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
783 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
784 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
785 build/{bin,etc,usr/bin,usr/local} \
786 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
787 log >> $LOGFILE
712d859c
MT
788 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
789 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
790 stdumount
791 ;;
792gettoolchain)
793 BUILDMACHINE=`uname -m`
794 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 795 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 796 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 797 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
798 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
799 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
800 cd $BASEDIR/cache/toolchains
5bd13f01 801 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
802 if [ $? -ne 0 ]; then
803 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 804 else
712d859c
MT
805 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
806 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
807 else
808 exiterror "$PACKAGE.md5 did not match, check downloaded package"
809 fi
40a4ea4c 810 fi
712d859c
MT
811 else
812 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
813 fi
814 ;;
15679d9f 815othersrc)
ce56e927 816 prepareenv
15679d9f 817 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
818 chroot $LFS /tools/bin/env -i HOME=/root \
819 TERM=$TERM PS1='\u:\w\$ ' \
820 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
821 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
822 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
823 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
824 if [ $? -eq "0" ]; then
825 beautify message DONE
826 else
827 beautify message FAIL
828 fi
ce56e927
MT
829 stdumount
830 ;;
c6cb9d25
MT
831svn)
832 case "$2" in
833 update|up)
cc0e56be 834 # clear
15679d9f 835 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
836 if [ $3 ]; then
837 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
838 else
839 svn update | tee -a $PWD/log/_build.svn.update.log
840 fi
15679d9f
MT
841 if [ $? -eq "0" ]; then
842 beautify message DONE
c6cb9d25 843 else
15679d9f 844 beautify message FAIL
c6cb9d25
MT
845 exit 1
846 fi
15679d9f 847 echo -ne "Writing the svn-info to a file"
c6cb9d25 848 svn info > $PWD/svn_status
15679d9f
MT
849 if [ $? -eq "0" ]; then
850 beautify message DONE
c6cb9d25 851 else
15679d9f 852 beautify message FAIL
c6cb9d25
MT
853 exit 1
854 fi
712d859c 855 chmod 755 $0
cc0e56be 856 exit 0
c6cb9d25
MT
857 ;;
858 commit|ci)
859 clear
6b8cff41
MT
860 if [ -f /usr/bin/mcedit ]; then
861 export EDITOR=/usr/bin/mcedit
73d9a908
MT
862 fi
863 if [ -f /usr/bin/nano ]; then
864 export EDITOR=/usr/bin/nano
6b8cff41
MT
865 fi
866 echo -ne "Selecting editor $EDITOR..."
867 beautify message DONE
d79b46cb 868 if [ -e /sbin/yast ]; then
028698e8
MT
869 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
870 $0 changelog
871 fi
d79b46cb 872 fi
8a5f0f44 873 update_langs
15679d9f 874 svn commit
c6cb9d25 875 $0 svn up
1065bfea
MT
876 if [ -n "$FTP_CACHE_URL" ]; then
877 $0 uploadsrc
878 fi
c6cb9d25
MT
879 ;;
880 dist)
7471f6ab
MT
881 if [ $3 ]; then
882 SVN_REVISION=$3
883 fi
884 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
885 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
886 exit 0
887 fi
888 echo -en "REV $SVN_REVISION: Downloading..."
223ad6a4
MT
889 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
890 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
891 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
892 evaluate 1
893
7471f6ab
MT
894 echo -en "REV $SVN_REVISION: Compressing files..."
895 if [ -e ipfire-source/trunk/make.sh ]; then
896 chmod 755 ipfire-source/trunk/make.sh
897 fi
9dc02b38 898 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 899 evaluate 1
7471f6ab 900 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 901 rm ipfire-source/ -r
15679d9f 902 evaluate 1
7471f6ab 903 ;;
028698e8 904 diff|di)
1a8688ba 905 update_langs
15679d9f 906 echo -ne "Make a local diff to last svn revision"
c6cb9d25 907 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 908 evaluate 1
c6cb9d25 909 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
bf7c473f 910 svn status
c6cb9d25
MT
911 ;;
912 esac
f9315063 913 ;;
15679d9f
MT
914uploadsrc)
915 PWD=`pwd`
916 cd $BASEDIR/cache/
917 echo -e "Uploading cache to ftp server:"
fd1b8061 918 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
15679d9f 919 for i in *; do
fd1b8061
MT
920 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
921 grep -q $(basename $i) /tmp/ftplist
0eab8e84 922 if [ "$?" -ne "0" ]; then
fd1b8061
MT
923 echo -ne "$(basename $i)"
924 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
6fb8ec08 925 if [ "$?" -ne "0" ]; then
15679d9f 926 beautify message FAIL
0eab8e84
MT
927 fi
928 fi
929 done
6fb8ec08 930 rm -f /tmp/ftplist
15679d9f
MT
931 cd $PWD
932 exit 0
0eab8e84 933 ;;
cc0e56be 934upload)
b2c64f8c
MT
935 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
936 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
937 if [ -z $FTP_ISO_PORT ]; then
938 FTP_ISO_PORT=21
939 fi
940 cat <<EOF > .ftp-commands
de2c999d 941mkdir -p $FTP_ISO_PATH$SVN_REVISION
b2c64f8c 942mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
9dc02b38
MT
943quit
944EOF
b2c64f8c
MT
945 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
946 rm -f .ftp-commands
947
948 case "$2" in
949 iso)
950 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
951
8f55c54e 952 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
dff9df9d
MT
953 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
954 if [ -e "$i" ]; then
b2c64f8c
MT
955 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
956 if [ "$?" -eq "0" ]; then
957 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
958 else
959 echo "There was an error while uploading the file $i to the ftp server."
960 exit 1
961 fi
dff9df9d 962 fi
b2c64f8c 963 done
a4c9c660 964 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
6aae8d61 965 if [ "$3" = "--with-sources-cd" ]; then
b2c64f8c 966 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 967 fi
cc0e56be
MT
968 ;;
969 paks)
b2c64f8c 970 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
cc0e56be 971 if [ "$?" -eq "0" ]; then
822c5bd0 972 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
cc0e56be
MT
973 else
974 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 975 exit 1
cc0e56be
MT
976 fi
977 ;;
978 esac
0d0521b6 979 ;;
cc0e56be 980batch)
c8582074 981 if [ "$2" = "--background" ]; then
15679d9f
MT
982 batch_script
983 exit $?
984 fi
27ac55bf 985 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
986 echo "Build is already running, sorry!"
987 exit 1
988 else
27ac55bf
MT
989 if [ "$2" = "--rebuild" ]; then
990 export IPFIRE_REBUILD=1
991 echo "REBUILD!"
992 else
993 export IPFIRE_REBUILD=0
994 fi
15679d9f
MT
995 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
996 screen -dmS ipfire $0 batch --background
997 evaluate 1
712d859c
MT
998 exit 0
999 fi
cc0e56be 1000 ;;
028698e8 1001watch)
15679d9f 1002 watch_screen
028698e8 1003 ;;
33634aa8
MT
1004pxe)
1005 case "$2" in
1006 start)
1007 start_tftpd
1008 ;;
1009 stop)
1010 stop_tftpd
1011 ;;
a50d04ab 1012 reload|restart)
33634aa8
MT
1013 reload_tftpd
1014 ;;
1015 esac
1016 exit 0
1017 ;;
bf7c473f
MT
1018lang)
1019 update_langs
1020 ;;
6b8cff41 1021"")
24a4a744
MT
1022 clear
1023 svn info
c3db995c 1024 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1025 do
1026 case $name in
c3db995c
MT
1027 "IPFIRE: Downloadsrc")
1028 $0 downloadsrc
c6cb9d25
MT
1029 ;;
1030 "IPFIRE: Build (silent)")
1031 $0 build-silent
1032 ;;
1033 "IPFIRE: Watch Build")
028698e8 1034 $0 watch
c6cb9d25 1035 ;;
712d859c
MT
1036 "IPFIRE: Batch")
1037 $0 batch
1038 ;;
c6cb9d25
MT
1039 "IPFIRE: Clean")
1040 $0 clean
1041 ;;
c6cb9d25
MT
1042 "SVN: Update")
1043 $0 svn update
1044 ;;
c6cb9d25 1045 "Help")
a50d04ab 1046 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1047 cat doc/make.sh-usage
1048 ;;
712d859c
MT
1049 "LOG: Tail")
1050 tail -f log/_*
1051 ;;
c6cb9d25
MT
1052 "Exit")
1053 break
1054 ;;
24a4a744
MT
1055 esac
1056 done
df5e82b3 1057 ;;
a50d04ab
MT
1058config)
1059 make_config
1060 ;;
6b8cff41 1061*)
a50d04ab 1062 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1063 cat doc/make.sh-usage
1064 ;;
3ea75603 1065esac